"""

Extended GNOME dialogs and classes

"""

from gnome.ui import GnomeQuestionDialog, GnomeApp
from gtk import events_pending, mainiteration, create_pixmap_from_xpm, GtkLabel, GtkPixmap, GtkHBox, GtkFrame, SHADOW_ETCHED_OUT, GtkVBox, GtkProgressBar
from time import sleep
from tools import TRUE, FALSE

targets = [('text/plain', 0, 1),
           ('text/uri-list', 0, 2),
	   ('STRING', 0, 3)]

class GnomeToolsQuestionDialog:

    def __init__(self, question):
        self.callbackdone = FALSE
        self.Result = FALSE
        GnomeQuestionDialog(question, self.callback)
        while (self.callbackdone == FALSE):
            while events_pending():
                mainiteration()
            sleep(0.01)

    def callback(self, result):
        self.callbackdone = TRUE
        self.Result = (result == 0)

class GnomeToolsXpmHBox:

    def __init__(self, window, text, xpm = None):
        label = GtkLabel(text)
        label.set_padding(2, 2)
        label.show()

        if (xpm != None):
            pix, mask = create_pixmap_from_xpm(window, None, xpm)
            pixmap = GtkPixmap(pix, mask)
            pixmap.show()

        self.GtkHBox =  GtkHBox()
        if (xpm != None):
            self.GtkHBox.add(pixmap)
        self.GtkHBox.add(label)
        self.GtkHBox.show()

class GnomeToolsPixmap:
    
    def __init__(self, window, xpm):
        pix, mask = create_pixmap_from_xpm(window, None, xpm)
        self.Pixmap = GtkPixmap(pix, mask)
        self.Pixmap.show()
        
    def pixmap(self):
        return self.Pixmap

class GnomeToolsProgressWindow:
   
    def __init__(self, title, text, maxvalue):
        self.maxvalue = maxvalue
        self.value = 0.0

        label = GtkLabel(text)
        label.show()

        self.progressbar = GtkProgressBar()
        self.progressbar.set_format_string("%d of %d" % (self.value, self.maxvalue));
        self.progressbar.set_show_text(TRUE)
        self.progressbar.show()

        vbox = GtkVBox()
        vbox.set_border_width(5)
        vbox.pack_start(label)
        vbox.pack_start(self.progressbar)
        vbox.show()
        
        waitframe = GtkFrame(" Please wait ")
        waitframe.set_border_width(5)
        waitframe.set_shadow_type(SHADOW_ETCHED_OUT)
        waitframe.add(vbox)
        waitframe.show()

        framebox = GtkVBox(spacing = 5)
        framebox.set_border_width(0)
        framebox.pack_start(waitframe)
        framebox.show()

        self.window = GnomeApp("ProgressWindow", title)
        self.window.set_border_width(5)
        self.window.set_contents(framebox)
        self.window.show()

        self.redraw()

    def redraw(self):
        # FIXME: make sure window is being drawn
        while events_pending():
            mainiteration()
        
    def update(self):
        self.redraw()
        self.value = self.value + 1
        if (self.value <= self.maxvalue):
            self.progressbar.set_format_string("%d of %d" % (self.value, self.maxvalue));
            self.progressbar.update(self.value / self.maxvalue)
        self.redraw()
        
    def close(self):
        self.window.destroy()
        self.windows = None
